package gp_dbc.items;

import JinRyuu.JRMCore.JRMCoreH;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.Main;
import gp_dbc.config.ConfigManager;
import gp_dbc.system.Handcuff;
import gp_dbc.utils.EntityUtils;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.EnumAction;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.IIcon;
import net.minecraft.world.World;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

import static gp_dbc.config.ConfigManager.*;

public class ItemGPHandcuff extends Item {

    // Scum|TimeStart
    public static HashMap<UUID, Long> handcuffing = new HashMap<>();

    private long timeStart;

    private IIcon open;
    private IIcon close;

    public ItemGPHandcuff() {
        setUnlocalizedName(Main.MODID +".gp_handcuff");
        GameRegistry.registerItem(this, getUnlocalizedName());
        setCreativeTab(Main.tabGP);
        setTextureName(Main.MODID + ":gp_handcuff");
        setMaxStackSize(2);
    }

    @Override
    @SideOnly(Side.SERVER)
    public void onPlayerStoppedUsing(ItemStack stack, World world, EntityPlayer player, int par4) {
        Entity entity = EntityUtils.getEntityLookedAt(player, 5);
        if (entity instanceof EntityPlayer) {
            EntityPlayer inmate = (EntityPlayer) entity;

            if (!handcuffing.containsKey(inmate.getUniqueID()))
                return;
            long startTime = handcuffing.get(inmate.getUniqueID());

            long time = (System.currentTimeMillis() - startTime) / 1000;

            if (time >= TIME_HANDCUFFING && time <= TIME_HANDCUFFING * 2L && Handcuff.putHandcuff(player, inmate))
                player.inventory.setInventorySlotContents(player.inventory.currentItem, new ItemStack(this, stack.stackSize - 1));
        }
    }

    @Override
    public ItemStack onItemRightClick(ItemStack stack, World world, EntityPlayer player) {

        if (!world.isRemote) {
            Entity entity = EntityUtils.getEntityLookedAt(player, 5);
            if (entity instanceof EntityPlayer) {
                EntityPlayer inmate = (EntityPlayer) entity;

                if (Handcuff.isHandcuffed(inmate)) {
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ERROR_ALREADY_HANDCUFFED));
                    return stack;
                }

                NBTTagCompound nbtPlayer = JRMCoreH.nbt(inmate, "pres");
                boolean ko = nbtPlayer.getInteger("jrmcHar4va") > 0;
                if (ko) {
                    if (Handcuff.putHandcuff(player, inmate))
                        player.inventory.setInventorySlotContents(player.inventory.currentItem, new ItemStack(this, stack.stackSize - 1));
                } else {
                    handcuffing.put(inmate.getUniqueID(), System.currentTimeMillis());
                    inmate.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + WARNING_HANDCUFFING_YOU));
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + WARNING_HANDCUFFING_HIM));
                    System.out.println("handcuffing not ko");
                }
            }
        }
        player.setItemInUse(stack, getMaxItemUseDuration(stack));
        timeStart = System.currentTimeMillis();

        //System.out.println(itemStack.stackSize);
        return stack;
    }

    @SuppressWarnings({ "unchecked" })
    @Override
    public void addInformation(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, List par3List, boolean par4) {
        par3List.add("Right Click to put in jail");
    }

    public int getMaxItemUseDuration(ItemStack par1ItemStack) {
        return 72000;
    }
    public EnumAction getItemUseAction(ItemStack stack) {
        return EnumAction.block;
    }

    public IIcon getIcon(ItemStack stack, int renderPass, EntityPlayer player, ItemStack usingItem, int useRemaining)
    {
        long timeUsing = (System.currentTimeMillis() - timeStart) / 1000;
        if (useRemaining <= 0)
            return getIcon(stack, renderPass);
        else if (timeUsing >= 0 && timeUsing < TIME_HANDCUFFING )
            return open;
        else
            return close;
    }

    @SideOnly(Side.CLIENT)
    public void registerIcons(IIconRegister iconRegister) {

        this.itemIcon = iconRegister.registerIcon(Main.MODID + ":gp_handcuff");
        this.open = iconRegister.registerIcon(Main.MODID + ":gp_handcuff_open");
        this.close = iconRegister.registerIcon(Main.MODID + ":gp_handcuff_close");
    }

}
